"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("@testing-library/react-native");
var _1 = require(".");
require("jest-styled-components");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_native_2 = require("react-native");
function ComponentMock() {
    function openActionSheet() {
        _1.ActionSheet.show({
            options: [
                { text: "Editar", key: 'edit', icon: free_solid_svg_icons_1.faPen },
                { text: 'Deletar', key: 'delete', icon: free_solid_svg_icons_1.faTrashAlt, iconColor: 'red' },
                { text: 'Cancelar', key: 'cancel', icon: free_solid_svg_icons_1.faTimes, cancel: true },
            ],
            onPress: function (el, index) {
                console.log('sdsd');
            },
        });
    }
    return (react_1.default.createElement(react_native_2.View, { style: { flex: 1 } },
        react_1.default.createElement(react_native_2.View, null,
            react_1.default.createElement(react_native_2.Button, { title: "Open ActionSheet", onPress: function () { return openActionSheet(); }, testID: "btn" })),
        react_1.default.createElement(_1.ActionSheet, null)));
}
it('snapshot - padrão', function () {
    var toJSON = react_native_1.render(react_1.default.createElement(ComponentMock, null)).toJSON;
    expect(toJSON()).toMatchSnapshot();
});
it('snapshot - open actionsheet', function () {
    var _a = react_native_1.render(react_1.default.createElement(ComponentMock, null)), toJSON = _a.toJSON, getByTestId = _a.getByTestId, queryByTestId = _a.queryByTestId;
    expect(queryByTestId('action-sheet')).toBeNull();
    react_native_1.fireEvent.press(getByTestId('btn'));
    expect(queryByTestId('action-sheet')).not.toBeNull();
    expect(toJSON()).toMatchSnapshot();
});
it('snapshot - close actionSheet', function () { return __awaiter(void 0, void 0, void 0, function () {
    function ComponentActionSheet() {
        function openActionSheet() {
            _1.ActionSheet.show({
                options: [
                    { text: "Editar", key: 'edit', icon: free_solid_svg_icons_1.faPen },
                    { text: 'Deletar', key: 'delete', icon: free_solid_svg_icons_1.faTrashAlt, iconColor: 'red' },
                    { text: 'Cancelar', key: 'cancel', icon: free_solid_svg_icons_1.faTimes, cancel: true },
                ],
                onPress: function (el, index) { },
            });
        }
        return (react_1.default.createElement(react_native_2.View, { style: { flex: 1 } },
            react_1.default.createElement(react_native_2.View, null,
                react_1.default.createElement(react_native_2.Button, { title: "Open ActionSheet", onPress: function () { return openActionSheet(); }, testID: "btn" })),
            react_1.default.createElement(_1.ActionSheet, null)));
    }
    var _a, toJSON, getByTestId, queryByTestId;
    return __generator(this, function (_b) {
        _a = react_native_1.render(react_1.default.createElement(ComponentActionSheet, null)), toJSON = _a.toJSON, getByTestId = _a.getByTestId, queryByTestId = _a.queryByTestId;
        react_native_1.fireEvent.press(getByTestId('btn'));
        expect(queryByTestId('action-sheet')).not.toBeNull();
        react_native_1.act(function () {
            react_native_1.fireEvent.press(getByTestId('action-sheet-item-1'));
        });
        expect(queryByTestId('action-sheet')).toBeNull();
        return [2];
    });
}); });
it('onPress Item', function (done) { return __awaiter(void 0, void 0, void 0, function () {
    function ComponentActionSheet() {
        function openActionSheet() {
            _1.ActionSheet.show({
                options: [
                    { text: "Editar", key: 'edit', icon: free_solid_svg_icons_1.faPen },
                    { text: 'Deletar', key: 'delete', icon: free_solid_svg_icons_1.faTrashAlt, iconColor: 'red' },
                    { text: 'Cancelar', key: 'cancel', icon: free_solid_svg_icons_1.faTimes, cancel: true },
                ],
                onPress: function (el, index) {
                    expect(el.key).toEqual('delete');
                    done();
                },
            });
        }
        return (react_1.default.createElement(react_native_2.View, { style: { flex: 1 } },
            react_1.default.createElement(react_native_2.View, null,
                react_1.default.createElement(react_native_2.Button, { title: "Open ActionSheet", onPress: function () { return openActionSheet(); }, testID: "btn" })),
            react_1.default.createElement(_1.ActionSheet, null)));
    }
    var _a, toJSON, getByTestId, queryByTestId;
    return __generator(this, function (_b) {
        _a = react_native_1.render(react_1.default.createElement(ComponentActionSheet, null)), toJSON = _a.toJSON, getByTestId = _a.getByTestId, queryByTestId = _a.queryByTestId;
        expect(queryByTestId('action-sheet')).toBeNull();
        react_native_1.fireEvent.press(getByTestId('btn'));
        react_native_1.fireEvent.press(getByTestId('action-sheet-item-1'));
        return [2];
    });
}); });
//# sourceMappingURL=ActionSheet.spec.native.js.map