"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Input = void 0;
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var core_1 = require("@unform/core");
var services_1 = require("../../../services");
var mask_utils_1 = require("../../MaskText/mask.utils");
var Input_style_1 = require("./Input.style");
exports.Input = react_1.default.forwardRef(function Input(props, ref) {
    props = __assign({ decimals: 0 }, props);
    var name = props.name, title = props.title, _a = props.textRight, textRight = _a === void 0 ? false : _a, _b = props.textCenter, textCenter = _b === void 0 ? false : _b, prefix = props.prefix, _c = props.decimals, decimals = _c === void 0 ? 0 : _c, themeInput = props.theme, suffix = props.suffix, _d = props.loading, loading = _d === void 0 ? false : _d, _e = props.onEnter, onEnter = _e === void 0 ? function () { } : _e, _f = props.number, number = _f === void 0 ? false : _f, _g = props.withoutDotNumber, withoutDotNumber = _g === void 0 ? false : _g, _h = props.CEP, CEP = _h === void 0 ? false : _h, _j = props.CNPJ, CNPJ = _j === void 0 ? false : _j, _k = props.CPF, CPF = _k === void 0 ? false : _k, _l = props.RG, RG = _l === void 0 ? false : _l, _m = props.phone, phone = _m === void 0 ? false : _m, _o = props.noSpaces, noSpaces = _o === void 0 ? false : _o, rest = __rest(props, ["name", "title", "textRight", "textCenter", "prefix", "decimals", "theme", "suffix", "loading", "onEnter", "number", "withoutDotNumber", "CEP", "CNPJ", "CPF", "RG", "phone", "noSpaces"]);
    var inputRef = react_1.useRef();
    react_1.useImperativeHandle(ref, function () { return inputRef.current; }, [inputRef]);
    var _p = core_1.useField(name), registerField = _p.registerField, _q = _p.defaultValue, defaultValue = _q === void 0 ? '' : _q, error = _p.error, fieldName = _p.fieldName;
    var defaultValueInput = mask_utils_1.maskValue(defaultValue, props);
    var _r = react_1.useState(false), focus = _r[0], setFocus = _r[1];
    var _s = react_1.useState(defaultValueInput), value = _s[0], setValue = _s[1];
    react_1.useEffect(function () {
        registerField({
            name: fieldName,
            ref: inputRef.current,
            path: 'value',
            setValue: function (_ref, value) {
                inputRef.current.value = mask_utils_1.maskValue(value, props);
            },
            getValue: function (_ref) {
                if (number)
                    return services_1.OnlyNumbers(_ref.value);
                if (CEP)
                    return services_1.OnlyNumbers(_ref.value);
                return _ref.value;
            },
        });
    }, [fieldName, registerField]);
    var forceShowTitle = false;
    var _t = react_1.useState(false), hasText = _t[0], setHasText = _t[1];
    var animateTitle = react_1.useRef(new react_native_1.Animated.Value(forceShowTitle ? 1 : 0)).current;
    react_1.useEffect(function () {
        if (!forceShowTitle) {
            if (focus) {
                react_native_1.Animated.timing(animateTitle, {
                    toValue: 1,
                    duration: 150,
                    useNativeDriver: true,
                }).start();
            }
            else if (!hasText) {
                react_native_1.Animated.timing(animateTitle, {
                    toValue: 0,
                    duration: 150,
                    useNativeDriver: true,
                }).start();
            }
        }
    }, [focus]);
    return (react_1.default.createElement(Input_style_1.Container, null,
        title && (react_1.default.createElement(react_native_1.Animated.View, { style: {
                opacity: animateTitle,
                transform: [
                    {
                        translateY: animateTitle.interpolate({
                            inputRange: [0, 1],
                            outputRange: [25, 0],
                        }),
                    },
                ],
                zIndex: focus ? 1 : 0,
            } },
            react_1.default.createElement(Input_style_1.TitleText, null, title))),
        react_1.default.createElement(Input_style_1.InputContainer, { focus: focus, error: !!error },
            prefix && react_1.default.createElement(Input_style_1.Prefix, null, prefix),
            react_1.default.createElement(Input_style_1.InputStyle, { themeInput: themeInput, ref: inputRef, keyboardAppearance: "dark", defaultValue: defaultValueInput, placeholder: focus ? '' : title, keyboardType: number ? 'numeric' : 'default', onChangeText: function (_value) {
                    setHasText(!!_value);
                    if (inputRef.current) {
                        inputRef.current.value = mask_utils_1.maskValue(_value, props);
                    }
                    setValue(mask_utils_1.maskValue(_value, props));
                }, onFocus: function () { return setFocus(true); }, onBlur: function () { return setFocus(false); }, prefix: !!prefix, suffix: !!suffix, textRight: textRight, textCenter: textCenter, value: value }),
            suffix && react_1.default.createElement(Input_style_1.Suffix, null, suffix)),
        !!error && react_1.default.createElement(Input_style_1.TextError, null, error)));
});
//# sourceMappingURL=Input.js.map