import { createContext } from 'react';
import { History } from 'history';
import { IPropsPureSelect } from '../Select/Select.interface';

export interface IAppContext {
   // History para gerenciar
   history?: History<any>;
   // Imagem da página de não encontrado
   imageNotFound?: any;
   // Imagem da página de erro
   imagePageError?: any;
   // Key do youtube
   keyYTB?: string;
   // Font Family
   native?: {
      // Font
      fontFamily?: string;
      // Weight default da font
      fontWeightDefault?: string;
   };
   // Components
   pureComponents?: {
      Input: any;
      Select: React.FunctionComponent<IPropsPureSelect>;
   };
}

export default createContext<IAppContext>({} as IAppContext);
