import React from 'react';
import Style from './CloseBtn.style';

interface IPropsBtnClose extends React.ComponentProps<any> {
   size?: number;
   color?: string;
}

export const CloseBtn: React.FunctionComponent<IPropsBtnClose> = ({ size = 24, color, onClick }: IPropsBtnClose) => {
   return (
      <span data-testid="close-btn" onClick={onClick}>
         <Style color={color} size={size} />
      </span>
   );
};
