import React from 'react';
import { Animated, StyleProp, ViewStyle, View } from 'react-native';

interface IFlexProps extends React.ComponentProps<any> {
   flex?: number;
   horizontal?: boolean;
   vertical?: boolean;
}

export const Flex: React.FunctionComponent<IFlexProps> = ({ flex, horizontal, vertical, children }) => {
   const style: StyleProp<ViewStyle> = {};

   if (flex) style.flex = flex;
   if (horizontal) style.flexDirection = 'row';
   if (vertical) style.flexDirection = 'column';

   return <View style={style}>{children}</View>;
};
