## Modal (Web)

### Descrição

Componente Modal

### Uso:

```tsx
import React from 'react';
import { Modal, CloseBtn } from 'react-lib';

const AppComponent = () => {
   const [show, setShow] = useState(true);

   return (
      <div>
         <Modal show={'desktop'} onHide={() => console.log('hide modal')}>
            <Modal.Body>
               <CloseBtn onClick={() => setShow(false)} />
               <h2>Title</h2>
               <p>Modal example</p>
            </Modal.Body>
         </Modal>
      </div>
   );
};
```

### Opções:

| Nome              | Tipo         | Descrição                |
| ----------------- | ------------ | ------------------------ |
| show (Opcional)   | `boolean`    | Ver/esconder Modal       |
| onHide (Opcional) | `() => void` | Callback ao fechar modal |
