import React, { useContext } from 'react';
import AppContext from '../../AppProvider/AppContext';

export interface IPropsNotFoundListing extends React.ComponentProps<any> {
   image?: any;
}

export const PageListingNotFound: React.FunctionComponent<IPropsNotFoundListing> = ({
   image,
}: IPropsNotFoundListing) => {
   const { imageNotFound } = useContext(AppContext);

   return (
      <div className="not-found text-center">
         <div className="icon pb-3">
            <img src={image ?? imageNotFound} width="150px" />
         </div>

         <h3>Não encontramos nenhum resultado com esse filtro</h3>
      </div>
   );
};
