## Abas (Web)

### Uso:

```tsx
import React from 'react';
import { Tabs, ITab } from 'react-lib';

const optionsTabs: ITab[] = [
   {
      id: 1,
      name: 'AAA',
   },
   {
      id: 2,
      name: 'BBB',
   },
   {
      id: 3,
      name: 'CCC',
   },
   {
      id: 4,
      name: 'DDD',
   },
];

const AppComponent = () => {
   function onSelect(tab: ITab): void {
      expect(tab).toEqual({ id: 2, name: 'BBB' });
   }

   return (
      <div>
         <Tabs options={optionsTabs} defaultTab={1} onSelect={onSelect} />
      </div>
   );
};
```

### Opções:

| Nome                  | Tipo                  | Descrição                 |
| --------------------- | --------------------- | ------------------------- |
| options (Opcional)    | `ITab[]`              | Array de Abas             |
| onSelect (Opcional)   | `(tab: ITab) => void` | Callback ao clicar na aba |
| skeleton (Opcional)   | `boolean`             | Mostrar skeleton das abas |
| defaultTab (Opcional) | `string|number`       | Id da aba inicial         |
