import styled from 'styled-components';

const css = styled.div;

export const TagsFiltersStyle = css`
   @keyframes fadeInScale {
      0% {
         transform: scale(0);
      }
      100% {
         transform: scale(1);
      }
   }

   .search-tags {
      .tag {
         background: #fff;
         border-radius: 32px;
         border: 1px solid ${(props) => props.theme.primary};
         color: ${(props) => props.theme.primary};
         cursor: pointer;
         display: inline-block;
         font-size: 13px;
         height: 28px;
         line-height: 27px;
         position: relative;
         padding: 0 32px 0 12px;
         font-weight: 600;
         margin: 2px;
         vertical-align: top;
         opacity: 1;
         animation-name: fadeInScale;
         animation-iteration-count: 1;
         animation-duration: 0.1s;

         &:before {
            border-radius: 50%;
            color: ${(props) => props.theme.primary};
            content: '×';
            display: inline-block;
            font-size: 20px;
            height: 14px;
            line-height: 14px;
            padding: 1px;
            position: absolute;
            right: 8px;
            text-align: center;
            top: 5px;
            width: 14px;
            font-weight: 500;
         }
      }
   }

   b {
      font-weight: 800;
   }
`;
