## useMemoImmer

### Descrição

Hook igual useMemo, só que para variáveis complexas.

### Uso:

```tsx
import React, { useState } from 'react';
import { useMemoImmer } from 'react-lib';

const AppComponent = () => {
    const [value, setValue] = useState();
    const person = useMemoImmer(() => {}, [value]);

    return <div className="App"></div>;
};
```

### Parametros:

| Nome     | Tipo               | Descrição      |
| -------- | ------------------ | -------------- |
| [0] fn   | `factory: () => T` | Função factory |
| [1] deps | `deps: any[]`      | Dependências   |

### Retorno:

| Nome         | Tipo  | Descrição                           |
| ------------ | ----- | ----------------------------------- |
| `[0] (fn())` | `<T>` | Retorna o retorno da função enviada |
