import { useRoute, useNavigation } from '@react-navigation/native';
import useDeepCompareEffect from 'use-deep-compare-effect';
import { useImmer } from 'use-immer';

export function useQueryString(path?: string): any {
   const route = useRoute();

   const [query, setQuery] = useImmer(route.params);

   useDeepCompareEffect(() => {
      setQuery(() => route.params);
   }, [route.params]);

   return [query, setQuery];
}
