## useSelectGroup

### Descrição

Hook para facilitar a seleção de items.

### Uso:

```tsx
import React, { useState } from 'react';
import { useSelectGroup } from 'react-lib';

const AppComponent = () => {
   const [onSelect, onUnselectAll, selected, isSelected] = useSelectGroup();
   const [resources, setResources] = useState([1, 2, 3, 4, 5, 6, 7]);

   return (
      <div>
         <button onClick={() => onUnselectAll()}>Unselect All</button>
         {resources &&
            resources.map((resource) => (
               <div style={{ color: isSelected(resource) ? 'red' : 'black' }}>
                  Select ID
                  <button onClick={() => onSelect(resource)}>Select</button>
               </div>
            ))}
      </div>
   );
};
```

### Retorno:

| Nome                  | Tipo                                               | Descrição                             |
| --------------------- | -------------------------------------------------- | ------------------------------------- |
| `[0] (onSelect)`      | `(resurceId: any, select: boolean = true) => void` | Adicionar/Remover id aos selecionados |
| `[1] (onUnselectAll)` | `() => void`                                       | Remove todos os ids selecionados      |
| `[2] (selected)`      | `any []`                                           | Ids selecionados                      |
| `[1] (isSelected)`    | `(resurceId: any) => booleam`                      | Verifica se id está selecionado       |
