## useSharedData

### Descrição

Hook para atualizações de dados não interligados.

### Uso:

```tsx
import React, { useState } from 'react';
import { useSharedData } from 'react-lib';

const AppComponent = () => {
   const [onChange, setData] = useSharedData('data#1');

   return <div></div>;
};
```

### Parametros:

| Nome       | Tipo     | Descrição    |
| ---------- | -------- | ------------ |
| `[0] name` | `string` | Nome do dado |

### Retorno:

| Nome             | Tipo                                      | Descrição                            |
| ---------------- | ----------------------------------------- | ------------------------------------ |
| `[0] (onChange)` | `(fn: (value: T) => void) => any`         | Listener para quando dado for mudado |
| `[1] (setValue)` | `(value: T | any, name?: string) => void` | Define valor do dado                 |
